Index: /palm/trunk/SOURCE/salsa_util_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_util_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_util_mod.f90	(revision 3864)
@@ -25,7 +25,10 @@
 ! -----------------
 ! $Id$
+! Formatting changes
+!
+! 3845 2019-04-01 13:41:55Z monakurppa
 ! Initial revision
-! 
-! 
+!
+!
 !
 ! Authors:
@@ -39,83 +42,84 @@
 !------------------------------------------------------------------------------!
  MODULE salsa_util_mod
- 
+
+    USE control_parameters,                                                                        &
+        ONLY:  message_string
+
     USE kinds
-    
+
     USE pegrid
-    
+
     IMPLICIT NONE
-    
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_salsa_ws_l !< subdomain sum 
-                                        !< of vertical passive salsa flux w's' 
-                                        !< (5th-order advection scheme only)
 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_salsa_ws_l !< subdomain sum of vertical salsa 
+                                                              !< flux w's' (5th-order advection 
+                                                              !< scheme only)
+!
 !-- Component index
     TYPE component_index
-       INTEGER(iwp) ::  ncomp !< Number of components
-       INTEGER(iwp), ALLOCATABLE ::  ind(:) !< Component index
-       CHARACTER(len=3), ALLOCATABLE ::  comp(:) !< Component name
-    END TYPE component_index 
-    
+       INTEGER(iwp) ::  ncomp  !< Number of components
+       INTEGER(iwp), ALLOCATABLE ::  ind(:)  !< Component index
+       CHARACTER(len=3), ALLOCATABLE ::  comp(:)  !< Component name
+    END TYPE component_index
+
     SAVE
-    
+
     INTERFACE component_index_constructor
        MODULE PROCEDURE component_index_constructor
     END INTERFACE component_index_constructor
-    
+
     INTERFACE get_index
        MODULE PROCEDURE get_index
     END INTERFACE get_index
-    
-    INTERFACE get_n_comp
-       MODULE PROCEDURE get_n_comp
-    END INTERFACE get_n_comp
-    
+
     INTERFACE is_used
        MODULE PROCEDURE is_used
     END INTERFACE is_used
-    
+
     PRIVATE
-    PUBLIC component_index, component_index_constructor, get_index, get_n_comp,&
-           is_used, sums_salsa_ws_l
-    
+    PUBLIC component_index, component_index_constructor, get_index, is_used, sums_salsa_ws_l
+
  CONTAINS
-    
-!------------------------------------------------------------------------------!    
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Creates index tables for different (aerosol) components 
 !------------------------------------------------------------------------------!
-    SUBROUTINE component_index_constructor( SELF, ncomp, nlist, listcomp )
+    SUBROUTINE component_index_constructor( self, ncomp, nlist, listcomp )
 
        IMPLICIT NONE
-       
-       TYPE(component_index), INTENT(inout) ::  SELF !< Object containing the indices 
-                                                     !< of different aerosol components
-       INTEGER(iwp), INTENT(inout) ::  ncomp !< Number of components
-       INTEGER(iwp), INTENT(in) ::     nlist !< Maximum number of components
-       CHARACTER(len=3), INTENT(in) ::  listcomp(nlist) !< List cof component
-                                                        !< names
-       INTEGER(iwp) ::  i, jj
-       
+
+       INTEGER(iwp) ::  i   !<
+       INTEGER(iwp) ::  jj  !<
+
+       INTEGER(iwp), INTENT(in) ::  nlist ! < Maximum number of components
+
+       INTEGER(iwp), INTENT(inout) ::  ncomp  !< Number of components
+
+       TYPE(component_index), INTENT(inout) ::  self  !< Object containing the indices of different
+                                                      !< aerosol components
+       CHARACTER(len=3), INTENT(in) ::  listcomp(nlist)  !< List cof component names
+
        ncomp = 0
-       
-       DO  WHILE ( listcomp(ncomp+1) /= '  ' .AND. ncomp < nlist )
+
+       DO WHILE ( listcomp(ncomp+1) /= '  ' .AND. ncomp < nlist )
           ncomp = ncomp + 1
        ENDDO
-       
-       SELF%ncomp = ncomp 
-       ALLOCATE( SELF%ind(ncomp), SELF%comp(ncomp) )
-       
-       DO i = 1, ncomp
-          SELF%ind(i) = i
+
+       self%ncomp = ncomp
+       ALLOCATE( self%ind(ncomp), self%comp(ncomp) )
+
+       DO  i = 1, ncomp
+          self%ind(i) = i
        ENDDO
-       
+
        jj = 1
-       DO i = 1, nlist
+       DO  i = 1, nlist
           IF ( listcomp(i) == '') CYCLE
-          SELF%comp(jj) = listcomp(i)
-          jj = jj+1
+          self%comp(jj) = listcomp(i)
+          jj = jj + 1
        ENDDO
-       
+
     END SUBROUTINE component_index_constructor
 
@@ -125,46 +129,29 @@
 !> Gives the index of a component in the component list
 !------------------------------------------------------------------------------!
-    INTEGER FUNCTION get_index( SELF, incomp )
+    INTEGER FUNCTION get_index( self, incomp )
 
        IMPLICIT NONE
-       
-       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
-                                                  !< indices of different 
-                                                  !< aerosol components
+
        CHARACTER(len=*), INTENT(in) ::  incomp !< Component name
        INTEGER(iwp) ::  i
-       
-       IF ( ANY(SELF%comp == incomp) ) THEN
+
+       TYPE(component_index), INTENT(in) ::  self  !< Object containing the indices of different
+                                                   !< aerosol components
+       IF ( ANY( self%comp == incomp ) ) THEN
           i = 1
-          DO WHILE ( (SELF%comp(i) /= incomp) )
-             i = i+1
+          DO WHILE ( (self%comp(i) /= incomp) )
+             i = i + 1
           ENDDO
           get_index = i
        ELSEIF ( incomp == 'H2O' ) THEN
-          get_index = SELF%ncomp + 1
+          get_index = self%ncomp + 1
        ELSE
-          STOP 1 ! "INFO for Developer: please use the message routine to pass the output string" get_index: FAILED, no such component -
+          WRITE( message_string, * ) 'Incorrect component name given!'
+          CALL message( 'get_index', 'PA0591', 1, 2, 0, 6, 0 )
        ENDIF
-       
+
        RETURN
-       
+
     END FUNCTION get_index
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Get the number of (aerosol) components used
-!------------------------------------------------------------------------------!
-    INTEGER FUNCTION get_n_comp( SELF )
-
-       IMPLICIT NONE
-
-       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
-                                                  !< indices of different 
-                                                  !< aerosol components
-       get_n_comp = SELF%ncomp
-       RETURN
-       
-    END FUNCTION
 
 !------------------------------------------------------------------------------!
@@ -173,21 +160,19 @@
 !> Tells if the (aerosol) component is being used in the simulation
 !------------------------------------------------------------------------------!
-    LOGICAL FUNCTION is_used( SELF, icomp )
+    LOGICAL FUNCTION is_used( self, icomp )
 
        IMPLICIT NONE
-       
-       TYPE(component_index), INTENT(in) ::  SELF !< Object containing the 
-                                                  !< indices of different 
-                                                  !< aerosol components
+
        CHARACTER(len=*), INTENT(in) ::  icomp !< Component name
-       
-       IF ( ANY(SELF%comp == icomp) ) THEN
+
+       TYPE(component_index), INTENT(in) ::  self  !< Object containing the indices of different
+                                                   !< aerosol components
+
+       IF ( ANY(self%comp == icomp) ) THEN
           is_used = .TRUE.
        ELSE
           is_used = .FALSE.
        ENDIF
-       
-       RETURN
-       
+
     END FUNCTION
 
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3863)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3864)
@@ -25,4 +25,14 @@
 ! -----------------
 ! $Id$
+! Modifications made for salsa:
+! - Call salsa_emission_update at each time step but do the checks within
+!   salsa_emission_update (i.e. skip_time_do_salsa >= time_since_reference_point
+!   and next_aero_emission_update <= time_since_reference_point ).
+! - Renamed nbins --> nbins_aerosol, ncc_tot --> ncomponents_mass and 
+!   ngast --> ngases_salsa and loop indices b, c and sg to ib, ic and ig
+! - Apply nesting for salsa variables
+! - Removed cpu_log calls speciffic for salsa.
+! 
+! 3833 2019-03-28 15:04:04Z forkel
 ! added USE chem_gasphase_mod, replaced nspec by nvar since fixed compounds are not integrated
 ! 
@@ -567,5 +577,5 @@
     USE nesting_offl_mod,                                                                          &
         ONLY:  nesting_offl_bc, nesting_offl_mass_conservation
-        
+
     USE netcdf_data_input_mod,                                                                     &
         ONLY:  chem_emis, chem_emis_att, nest_offl, netcdf_data_input_offline_nesting
@@ -591,8 +601,9 @@
         ONLY: dt_radiation, force_radiation_call, radiation, radiation_control,                    &
               radiation_interaction, radiation_interactions, skip_time_do_radiation, time_radiation
-         
+
     USE salsa_mod,                                                                                 &
-        ONLY: aerosol_number, aerosol_mass, nbins, ncc_tot, ngast, salsa_boundary_conds,           &
-              salsa_gas, salsa_gases_from_chem, skip_time_do_salsa
+        ONLY: aerosol_number, aerosol_mass, bc_am_t_val, bc_an_t_val, bc_gt_t_val,                 &
+              nbins_aerosol, ncomponents_mass, ngases_salsa, salsa_boundary_conds,                 &
+              salsa_emission_update, salsa_gas, salsa_gases_from_chem, skip_time_do_salsa
 
     USE spectra_mod,                                                                               &
@@ -629,5 +640,5 @@
                vnest_boundary_conds_khkm, vnest_deallocate, vnest_init, vnest_init_fine,           &
                vnest_start_time
-               
+
     USE virtual_measurement_mod,                                                                   &
         ONLY:  vm_data_output, vm_sampling, vm_time_start
@@ -667,8 +678,9 @@
 
     CHARACTER (LEN=9) ::  time_to_string   !<
-    
-    INTEGER(iwp)      ::  b !< index for aerosol size bins    
-    INTEGER(iwp)      ::  c !< index for chemical compounds in aerosol size bins
-    INTEGER(iwp)      ::  g !< index for gaseous compounds 
+
+    INTEGER(iwp)      ::  ib        !< index for aerosol size bins
+    INTEGER(iwp)      ::  ic        !< index for aerosol mass bins
+    INTEGER(iwp)      ::  icc       !< additional index for aerosol mass bins
+    INTEGER(iwp)      ::  ig        !< index for salsa gases
     INTEGER(iwp)      ::  lsp
     INTEGER(iwp)      ::  lsp_usr   !<
@@ -856,4 +868,21 @@
               ENDDO
            ENDIF
+           IF ( salsa  .AND.  time_since_reference_point >= skip_time_do_salsa )  THEN
+              DO  ib = 1, nbins_aerosol
+                 bc_an_t_val = ( aerosol_number(ib)%init(nzt+1) - aerosol_number(ib)%init(nzt) ) / &
+                               dzu(nzt+1)
+                 DO  ic = 1, ncomponents_mass
+                    icc = ( ic - 1 ) * nbins_aerosol + ib
+                    bc_am_t_val = ( aerosol_mass(icc)%init(nzt+1) - aerosol_mass(icc)%init(nzt) ) /&
+                                  dzu(nzt+1)
+                 ENDDO
+              ENDDO
+              IF ( .NOT. salsa_gases_from_chem )  THEN
+                 DO  ig = 1, ngases_salsa
+                    bc_gt_t_val = ( salsa_gas(ig)%init(nzt+1) - salsa_gas(ig)%init(nzt) ) /        &
+                                  dzu(nzt+1)
+                 ENDDO
+              ENDIF
+           ENDIF
        ENDIF
 !
@@ -1028,30 +1057,23 @@
           ENDIF
 
-          IF ( salsa  .AND.  time_since_reference_point >= skip_time_do_salsa )&
-          THEN
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
-             DO  b = 1, nbins
-                CALL exchange_horiz( aerosol_number(b)%conc_p, nbgp )
-                CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
-                CALL salsa_boundary_conds( aerosol_number(b)%conc_p, aerosol_number(b)%init )
-                CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
-                DO  c = 1, ncc_tot
-                   CALL exchange_horiz( aerosol_mass((c-1)*nbins+b)%conc_p, nbgp )
-                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
-                   CALL salsa_boundary_conds( aerosol_mass((c-1)*nbins+b)%conc_p,                  &
-                                              aerosol_mass((c-1)*nbins+b)%init )
-                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
+          IF ( salsa  .AND.  time_since_reference_point >= skip_time_do_salsa )  THEN
+!
+!--          Exchange ghost points and decycle boundary concentrations if needed
+             DO  ib = 1, nbins_aerosol
+                CALL exchange_horiz( aerosol_number(ib)%conc_p, nbgp )
+                CALL salsa_boundary_conds( aerosol_number(ib)%conc_p, aerosol_number(ib)%init )
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   CALL exchange_horiz( aerosol_mass(icc)%conc_p, nbgp )
+                   CALL salsa_boundary_conds( aerosol_mass(icc)%conc_p, aerosol_mass(icc)%init )
                 ENDDO
              ENDDO
              IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  g = 1, ngast
-                   CALL exchange_horiz( salsa_gas(g)%conc_p, nbgp ) 
-                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'start' )
-                   CALL salsa_boundary_conds( salsa_gas(g)%conc_p, salsa_gas(g)%init )
-                   CALL cpu_log( log_point_s(93), 'salsa decycle', 'stop' )
-             ENDDO
+                DO  ig = 1, ngases_salsa
+                   CALL exchange_horiz( salsa_gas(ig)%conc_p, nbgp )
+                   CALL salsa_boundary_conds( salsa_gas(ig)%conc_p, salsa_gas(ig)%init )
+                ENDDO
              ENDIF
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
-          ENDIF         
+          ENDIF
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
@@ -1108,5 +1130,5 @@
 
                 IF ( passive_scalar )  CALL exchange_horiz( s, nbgp )  
-               
+
                 IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
 
@@ -1120,4 +1142,23 @@
                    ENDDO
                 ENDIF
+
+                IF ( salsa  .AND. time_since_reference_point >= skip_time_do_salsa )  THEN
+                   DO  ib = 1, nbins_aerosol
+                      CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
+                      CALL salsa_boundary_conds( aerosol_number(ib)%conc, aerosol_number(ib)%init )
+                      DO  ic = 1, ncomponents_mass
+                         icc = ( ic - 1 ) * nbins_aerosol + ib
+                         CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
+                         CALL salsa_boundary_conds( aerosol_mass(icc)%conc, aerosol_mass(icc)%init )
+                      ENDDO
+                   ENDDO
+                   IF ( .NOT. salsa_gases_from_chem )  THEN
+                      DO  ig = 1, ngases_salsa
+                         CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
+                         CALL salsa_boundary_conds( salsa_gas(ig)%conc, salsa_gas(ig)%init )
+                      ENDDO
+                   ENDIF
+                ENDIF
+                CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
              ENDIF
@@ -1407,5 +1448,12 @@
           ENDIF
        ENDIF
-
+!
+!--    If required, consider aerosol emissions for the salsa model
+       IF ( salsa )  THEN
+!
+!--       Call emission routine to update emissions if needed
+          CALL salsa_emission_update
+
+       ENDIF
 !
 !--    If required, calculate indoor temperature, waste heat, heat flux
